"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var RedisCoreModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.RedisCoreModule = void 0;
const common_1 = require("@nestjs/common");
const common_constant_1 = require("./constants/common.constant");
const redis_constant_1 = require("./constants/redis.constant");
const redis_client_provider_1 = require("./providers/redis-client.provider");
const redis_util_1 = require("./utils/redis.util");
let RedisCoreModule = RedisCoreModule_1 = class RedisCoreModule {
    constructor(options, clientList) {
        this.options = options;
        this.clientList = clientList;
    }
    /**
     * 同步方式配置
     * @param options 配置信息
     * @returns 动态模块
     */
    static forRoot(options) {
        return {
            module: RedisCoreModule_1,
            providers: [redis_client_provider_1.createRedisClientListProvider(), ...redis_client_provider_1.createRedisClientProvider(), redis_util_1.RedisUtil, { provide: common_constant_1.OPTIONS_PROVIDER, useValue: options }],
            exports: [...redis_client_provider_1.createRedisClientProvider()]
        };
    }
    /**
     * 异步方式配置
     * @param options 配置信息
     * @returns 动态模块
     */
    static forRootAsync(options) {
        const asyncProviders = this.createAsyncProviders(options);
        return {
            module: RedisCoreModule_1,
            providers: [...asyncProviders, redis_client_provider_1.createRedisClientListProvider(), ...redis_client_provider_1.createRedisClientProvider(), redis_util_1.RedisUtil],
            exports: [...redis_client_provider_1.createRedisClientProvider()]
        };
    }
    /**
     * 创建异步Provider列表
     * @param options 异步配置
     * @returns Provider列表
     */
    static createAsyncProviders(options) {
        if (options.useExisting || options.useFactory) {
            return [this.createAsyncOptionsProvider(options)];
        }
        const useClass = options.useClass;
        return [
            this.createAsyncOptionsProvider(options),
            {
                provide: useClass,
                useClass
            }
        ];
    }
    /**
     * 创建异步Provider
     * @param options 异步配置
     * @returns Provider
     */
    static createAsyncOptionsProvider(options) {
        if (options.useFactory) {
            return {
                provide: common_constant_1.OPTIONS_PROVIDER,
                useFactory: options.useFactory,
                inject: options.inject || []
            };
        }
        const inject = [options.useClass || options.useExisting];
        return {
            provide: common_constant_1.OPTIONS_PROVIDER,
            useFactory: async (optionsFactory) => await optionsFactory.createRedisOptions(),
            inject
        };
    }
    onApplicationShutdown() {
        if (this.options.closeClient)
            this.clientList.forEach(client => (client.status === 'ready' ? client.quit().catch(() => ({})) : client.disconnect()));
    }
};
RedisCoreModule = RedisCoreModule_1 = __decorate([
    common_1.Global(),
    common_1.Module({}),
    __param(0, common_1.Inject(common_constant_1.OPTIONS_PROVIDER)),
    __param(1, common_1.Inject(redis_constant_1.REDIS_CLIENT_LIST_PROVIDER)),
    __metadata("design:paramtypes", [Object, Object])
], RedisCoreModule);
exports.RedisCoreModule = RedisCoreModule;
