"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RedisUtil = void 0;
const common_1 = require("@nestjs/common");
const redis_constant_1 = require("../constants/redis.constant");
let RedisUtil = class RedisUtil {
    constructor(redisClientList) {
        this.redisClientList = redisClientList;
    }
    /**
     * 获取所有的Redis客户端
     * @returns 客户端Map列表
     */
    getAllClient() {
        return this.redisClientList;
    }
    /**
     * 获取某一个Redis客户端
     * @param namespace 客户端命名空间
     * @returns Redis客户端
     */
    getClient(namespace = redis_constant_1.DEFAULT_REDIS_CLIENT_PROVIDER) {
        return this.redisClientList.get(namespace);
    }
};
RedisUtil = __decorate([
    common_1.Injectable(),
    __param(0, common_1.Inject(redis_constant_1.REDIS_CLIENT_LIST_PROVIDER)),
    __metadata("design:paramtypes", [Object])
], RedisUtil);
exports.RedisUtil = RedisUtil;
